#!/usr/local/bin/perl -w



my $filedata;			# The file we're editing
my $diskname;			# The name of this disk (/dev/r${diskname}c, that is)
my $disktype;			# SCSI or IDE (for the moment, anyway)
my $numsectors;			# Number of sectors on the disk
my $swapsize;			# Number of sectors to set off for swap
my $i;				# Iterator for the lines during printout

if (defined($ENV{ICDEV_SWAPSIZE}) && $ENV{ICDEV_SWAPSIZE} =~ /^\d+$/) {
    $swapsize = $ENV{ICDEV_SWAPSIZE}*2;	# 512 byte sectors, not 1K sectors.
} else {
    $swapsize = 128*1024*2;	# 128M swap by default
}
open(INFILE, "<$ARGV[0]") || die "Unable to open \"$ARGV[0]\"";
while(<INFILE>) {
    chomp $_;
    $filedata[$#filedata+1] = $_;
}
close(INFILE);
die "Doesn't look like a disklabel to ME (device)" if $filedata[0] !~ /^# \/dev\/r(.*)c:$/;
$diskname = $1;
if ($diskname =~ /^sd/) {
    if (!defined($ENV{WIPE_SCSI}) || ($ENV{WIPE_SCSI} ne "yes" && $ENV{WIPE_SCSI} ne "YES")) {
	print "If you really want to wipe a SCSI disk, set WIPE_SCSI to \"yes\"\n";
	exit 1;
    }
    $disktype = "SCSI";
} elsif($diskname =~ /^wd/) {
    $disktype = "IDE";
} else {
    print "Unknown type for disk \"$diskname\"\n";
    exit 1;
}

die "Too many lines ($#filedata > 22) for a 'disklabel $diskname auto' pre-initialized disk" if($#filedata > 22);
die "Doesn't look like a disklabel to ME (type)" if ($filedata[1] =~ s/^(type: ).*/$1$disktype/) != 1;
die "Doesn't look like a disklabel to ME (disk)" if ($filedata[2] =~ s/^(disk: ).*/$1$diskname/) != 1;
die "Doesn't look like a disklabel to ME (sectors/unit)" if ($filedata[10] !~ /^sectors\/unit: (\d+)$/);
$numsectors = $1;
die "Doesn't look like a disklabel to ME (partitions)" if ($filedata[19] !~ /^(\d+) partitions:$/);
$numpartitions = $1;
die "Looks like this was pre-labelled - bad deal" if ($filedata[21] !~ /^  c: /);
die "Looks like this was pre-labelled - bad deal" if (defined($filedata[22]) && $filedata[22] =~ /^  [a-z]: /);
die "Too few partitions ($numpartitions < 3)" if ($numpartitions < 3);
die "Disk is smaller than wanted swap-partition ($numsectors < $swapsize)" if ($numsectors < $swapsize);

$filedata[21] = sprintf("  a: %8d %8d %9s %8d %5d %5d", $numsectors-$swapsize, $swapsize, "4.2BSD", 0, 0, 0);
$filedata[22] = sprintf("  b: %8d %8d %9s %8d %5d %5d", $swapsize, 0, "swap", 0, 0, 0);
$filedata[23] = sprintf("  c: %8d %8d %9s %8d %5d %5d", $numsectors, 0, "unused", 0, 0, 0);
open(OUTFILE, ">$ARGV[0]") || die "Unable to write label back";
for($i=0; $i <= $#filedata; $i++) {
    print OUTFILE "$filedata[$i]\n";
}
close(OUTFILE);
